#pragma once

#ifdef __USE_PROFILE_IMG_BY_P2P__

#include "ActorInterface.h"

/////////////////////////////////////////////
#include "incconferenceintf.h"
#include "INpMsgrP2P.h"
/////////////////////////////////////////////


class CProfileImageActor;

class CProfileImageSender : public _INpStreamSessionEvents
{
public:
	CProfileImageSender(CProfileImageActor *pActor);
	virtual ~CProfileImageSender(void);

	void SetStreamSession(INpStreamSession * pSession, INpPacket * pPacket);

private:
	bool _SendCRC();
	bool _StartSend();
	void _Delete();

protected:
	// _INpStreamSessionEvents 
	virtual void CALLBACK NpStreamSession_OnConnect(INpStreamSession *pSession, int nResultCode, int nErrorCode);
	virtual void CALLBACK NpStreamSession_OnClose(INpStreamSession *pSession, int nSocketError, bool bRecvInvalidPacket);
	virtual void CALLBACK NpStreamSession_OnRecvPacket(INpStreamSession *pSession, INpPacket * pPacket);
	virtual void CALLBACK NpStreamSession_OnSendReady(INpStreamSession * /*pSession*/);


private:
	bool m_bStartSend;

	WSTRING m_strFileName;
	HANDLE m_hFile;
	DWORD m_dwWritten;
	DWORD m_dwFileSize;

	INpStreamSession * m_pSession;

	GTProfileImageSizeType m_eSizeType;
	CProfileImageActor *m_pProfileImageActor;
};

#endif